/*------------------------------------------------------------------
	Modul: CPXLIB.H
	Datum: 21.06.92
	!!! noch nicht ausprobiert !!!
 	------------------------------------------------------------------*/

#ifndef __CPXLIB__
#define __CPXLIB__


/*So sieht der Kopf eines CPX-Moduls aus*/
typedef struct
{
	unsigned int magic;							/*CPX-Kennung = 100*/

	struct{
		unsigned int reserved : 13;		/*reserviert*/
		unsigned int resident : 1;		/*Modul ist resident*/
		unsigned int bootinit : 1;		/*Modul wird beim Booten initialisiert*/
		unsigned int set_only : 1;		/*Modul ist nur set_only*/
		} flags;

	long         cpx_id;						/*eindeutige CPX-ID (4 ASCII-Zeichen)*/
	unsigned int cpx_version;				/*CPX-Versionsnummer*/
	char         i_text[14];				/*Icon-Name*/
  unsigned int icon[48];					/*Icon-Bitmap 32x24 Pixel*/

	struct{
		unsigned int i_color  : 4;
		unsigned int reserved : 4;
		unsigned int i_char   : 8;
		} i_info;											/*Iconfarbe*/

	char text[18];									/*Text neben Icon*/

	struct{
		unsigned int c_board : 4;
		unsigned int c_text  : 4;
		unsigned int pattern : 4;
		unsigned int c_back  : 4;
		} t_info;											/*Textfarbe*/

	char buffer[64];								/*nicht flchtiger Speicher*/
	char reserved[306];							/*reserviert*/
	} CPXHEAD;


/*Mausparameter*/
typedef struct
{
	int x;
	int y;
	int buttons;
	int kstate;
	} MRETS;


/*Struktur zur Verwaltung von CPX-Modulen*/
typedef struct _cpxlist
{
	char f_name[14];
	int  head_ok;
	int  segm_ok;

	struct{
		void *text_seg;					/*Adresse des TEXT-Segments*/
		long len_text;					/*Lnge   des TEXT-Segments*/
		void *data_seg;					/*Adresse des DATA-Segments*/
		long len_data;					/*Lnge   des DATA-Segments*/
		void *bss_seg;					/*Adresse des BSS -Segments*/
		long len_bss;						/*Lnge   des BSS -Segments*/
		} *segm;

	struct _cpxlist *next;		/*Zeiger auf nchste Liste*/
	CPXHEAD header;
	} CPX_LIST;


/*Funktionen und Flags die von XControl zur Verfgung gestellt werden*/
typedef struct
{
	int handle;
	int booting;
	int reserved;
	int SkipRshFix;

	CPX_LIST *cdecl ( *get_cpx_list )( void );
	int       cdecl ( *save_header  )( CPX_LIST *header );
	void      cdecl ( *rsh_fix      )( int num_objs, int num_frstr,
																		 int num_frimg, int num_tree,
																		 OBJECT  *rs_object,
																		 TEDINFO *rs_tedinfo,
																		 char    *rs_strings[],
																		 ICONBLK *rs_iconblk,
																		 BITBLK  *rs_bitblk,
																		 long *rs_frstr,
																		 long *rs_frimg,
																		 long *rs_trindex,
																		 struct foobar *rs_imdope );
	void      cdecl ( *rsh_obfix    )( OBJECT *tree, int ob );
	int       cdecl ( *Popup        )( char *items[],
																		 int num, int def_item, int font,
																		 GRECT *up, GRECT *world );
	void      cdecl ( *Sl_size      )( OBJECT *tree, int base, int slider,
																		 int entrys, int vis_ent,
																		 int hvflag, int min_pix );
	void      cdecl ( *Sl_x         )( OBJECT *tree, int base, int slider,
																		 int value, int min, int max,
																		 void (*foo)( void ));
	void      cdecl ( *Sl_y         )( OBJECT *tree, int base, int slider,
																		 int value, int min, int max,
																		 void (*foo)( void ));
	void      cdecl ( *Sl_arrow     )( OBJECT *tree, int base, int slider,
																		 int obj, int inc, int min, int max, int *value, int hvflag,
																		 void (*foo)( void ));
	void      cdecl ( *Sl_dragx     )( OBJECT *tree, int base, int slider,
																		 int min, int max, int *value,
																		 void (*foo)( void ));
	void      cdecl ( *Sl_dragy     )( OBJECT *tree, int base, int slider,
																		 int min, int max, int *value,
																		 void (*foo)( void ));
	int       cdecl ( *Xform_do     )( OBJECT *tree, int eobj, int *msg );
	GRECT    *cdecl ( *GetFirstRect )( GRECT *prect );
	GRECT    *cdecl ( *GetNextRect  )( void );
	void      cdecl ( *Set_Evnt_Mask)( int mask, MOBLK *m1, MOBLK *m2, long time );
	int       cdecl ( *XGen_Alert   )( int al );
	int       cdecl ( *CPX_Save     )( void *ptr, long bytes );
	void     *cdecl ( *Get_Buffer   )( void );
	int       cdecl ( *getcookie    )( long cookie, long *p_value );

	int               Country_Code;

	void      cdecl ( *MFsave       )( int flag, MFORM *mf );
	} XCPB;


/*Funktionen die vom CPX-Modul zur Verfgung gestellt werden*/
typedef struct
{
	int  cdecl ( *cpx_call   )( GRECT *rect );
	void cdecl ( *cpx_draw   )( GRECT *clip );
	void cdecl ( *cpx_wmove  )( GRECT *work );
	void cdecl ( *cpx_timer  )( int   *quit );
	void cdecl ( *cpx_key    )( int kstate, int key, int *quit );
	void cdecl ( *cpx_button )( MRETS *mrets, int nclicks, int *quit );
	void cdecl ( *cpx_m1     )( MRETS *mrets, int *quit );
	void cdecl ( *cpx_m2     )( MRETS *mrets, int *quit );
  int  cdecl ( *cpx_hook   )( int event, int *msg, MRETS *mrets, int *key, int *nclicks );
	void cdecl ( *cpx_close  )( int flag );
	} CPXINFO;

/* Ntzliche Definitionen*/
#define SAVE_DEFAULTS   0
#define MEM_ERR         1
#define FILE_ERR        2
#define FILE_NOT_FOUND  3

#define MFSAVE      1
#define MFRESTORE   0

#define CT_KEY  53

#else
#error __CPXLIB__ bereits definiert
#endif /*__CPXLIB__*/