/**************************************************************************
	Programm: KAOSCONF.CPX
	erstmals editiert				:	21.06.1992
	an MagiC angepasst				:	29.05.2005
	2.Sprache eingebaut				:	30.05.2005
	KAOS-TOS 30 bercksichtigt		:	03.06.2005
	Fehler beseitigt				:	04.06.2005
	zuletzt gendert				:	02.12.2005

	(c) Michael Schrter, Sdstr. 1a, 37269 Eschwege
	http://mia-net.gotdns.org/

	Benutzung dieses Freeware-Programms auf eigene Verantwortung! ;-)

    Das durch die Projektdatei entstandene KAOSCONF.CP mu danach
    noch mit dem LINK_CPX.CPX von Richard Kurz zu einem fertigen
    CPX-Modul gelinkt werden:
    - Header KAOSCONF.HDR laden
    - Sichern: Header mit CP linken
    Alternativ kann auch mit einem Commandline Tool die KAOSCONF.HDR mit
    der KAOSCONF.CP zu einer Datei KAOSCONF.CPX zusammengesetzt werden
    - mit der .HDR-Datei am Anfang.

	Die Resource wurde mit dem Freeware/PD Resource-Kit ORCS bearbeitet, da
	Interface die RSH-Datei nicht so erstellt, wie bentigt.

	Wenn MagiC >= 3.00 vorhanden ist, dann wird die 'Pfadberprfung' durch
	'Floppy-Hintergrund-DMA' ersetzt.
 **************************************************************************/

#include <aes.h>
#include <tos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <portab.h>			/*Nur fr Resource-Einbindung*/

#include "..\cpxlib.h"		/*CPX-Header Datei*/
#include "kaosconf.h"		/*Resource-Header Datei*/

#undef	WF_OWNER
#include <kaos.h>			/*KAOS-Definitionen*/
#define DOSVARS				/*die werden gleich nochmal...*/
#define SHELTAIL			/*...neu definiert*/
#undef	CH_EXIT
#include <magx.h>			/*MagiC-Definitionen*/


#pragma warn -rpt
#include "kaosconf.c"
#pragma warn +rpt

/*--Definitionen----------------------------------------------------*/
#define	TRUE		( 1 == 1 )
#define	FALSE		( 1 != 1 )
#define	_sysbase	(long) 0x4f2
#undef	SC_SET
#undef	SC_GET
#define	SC_GET		0x414B	/*'AK' Die Werte aus KAOSCONF.ACC erlauben...*/
#define	SC_SET		0x454C	/*'EL' Konfiguration der TOS-Kompatibilitt*/
#define	lang_GER	0
#define	lang_ENG	1

/*#define _DEBUG_*/
/*--Typen-----------------------------------------------------------*/

typedef struct
{
	long	kaosconf;
	int		language;
	int		saved;
} SAVEDATA;

/*--Variablen-------------------------------------------------------*/
GRECT *w_rect;			/*Die Koordinaten des Fensters*/
XCPB  *xcpb;			/*Zeiger auf die XControl-Funktionen*/

long			kaosvers;		/*Wert des KAOS-Cookie: Erstelldatum*/
int				kaos_ok;
long			magxvers;
int				magx_ok;
int				magx300;
unsigned int	tosvers;		/*TOS-Version*/

char	*kaosstrn =
	"XXXXXXXXX1XXXXXXXXX2XXXXXXXXX3XXXXXXXXX4XXXXXXXXX5XXXXXXXXX6XXXX";
char	*t_ein;
char	*t_aus;
char	*p_ein;
char	*p_aus;

char *month[ 2 ][ 12 ] =
{
	"Januar",  "Februar",  "Mrz",      "April",   "Mai",      "Juni",
	"Juli",    "August",   "September", "Oktober", "November", "Dezember",
	"January", "February", "March",     "April",   "May",      "June",
	"July",    "August",   "September", "October", "November", "December"
};


OBJECT *maindial;		/*Zeiger auf zu bearbeitenden Dialog*/
OBJECT *strgdial;		/*Zeiger auf Baum der Strings*/

CPXINFO cpxinfo;

extern SAVEDATA savedata;

/*--Funktions-Prototypen--------------------------------------------*/
CPXINFO *cdecl cpx_init	( XCPB *Xcpb );
int      cdecl cpx_call	( GRECT *re ); 

int  handle_dialog	( int button, int *msg );
void save_buffer	( void );
void load_buffer	( void );
void save_header	( void );
#ifdef _DEBUG_
void debug( const char *str, void *buffer );
#endif
void init_dialog	( void );
void set_te_ptext	( int object, long bitval );
void setup_dial		( void );
long tosversion		( void );
void upd_header		( long bitset );
long get_header		( void );
void object_xywh	( GRECT *therect, int object );
void handle_bitset	( int object, GRECT *rect );
void handle_info	( int object, GRECT *rect );
void set_language	( int, int );
void redraw_object	( int );
void object_draw	( int object, int depth, GRECT *clip );
void object_normal	( int object );
void set_config		( long val );
long get_config		( void );

/*--Funktionen------------------------------------------------------*/
/*
	!!!!!!!!!!!! cpx_init mu erste Funktion sein !!!!!!!!!!!!!!!!!!!!
	Es sollten nur wichtige Initialisierungen vorghenommen werden!
*/
CPXINFO *cdecl cpx_init( XCPB *Xcpb )
{
	xcpb = Xcpb;

	Supexec((* tosversion ));	/*TOS-Version feststellen*/

	kaos_ok = (( *xcpb->getcookie )( 'KAOS', &kaosvers ));
	if(! kaos_ok )
		kaos_ok = (( *xcpb->getcookie )( '_T30', &kaosvers ));
	magx_ok = (( *xcpb->getcookie )( 'MagX', &magxvers ));

	if( magx_ok && ((AESVARS *)
		((MAGX_COOKIE *) magxvers) -> aesvars ) -> version >= 0x0300 )
		magx300 = TRUE;

/*
	fr Test`s
*/
	/*kaos_ok = magx_ok = FALSE;*/
	/*magx_ok = FALSE; kaos_ok = TRUE;*/

#ifdef _DEBUG_
	printf( "\33H" );
#endif

	if( xcpb->booting )			/*Bei Boot-Initialisierung*/
	{
		if( savedata.saved )	
		{										/*Boot?*/
			set_config( savedata.kaosconf );	/*Dateieinstellungen!*/
			{
				SAVEDATA *sv = (SAVEDATA *) ( *xcpb->Get_Buffer )( );
				sv->kaosconf = savedata.kaosconf;
				sv->language = savedata.language;
				sv->saved = savedata.saved;
			}
		}

		return ((CPXINFO *) 1 );
	}


	if( !xcpb->SkipRshFix )
	{
		( *xcpb->rsh_fix )( NUM_OBS, NUM_FRSTR, NUM_FRIMG, NUM_TREE,
			rs_object, rs_tedinfo, rs_strings, rs_iconblk,
			rs_bitblk, rs_frstr, rs_frimg, rs_trindex, rs_imdope );
	}

	maindial = (OBJECT *) rs_trindex[ MAINDIAL ];
	strgdial = (OBJECT *) rs_trindex[ STRGDIAL ];

	cpxinfo.cpx_call    = cpx_call;
	cpxinfo.cpx_draw    = NULL;
	cpxinfo.cpx_wmove   = NULL;
	cpxinfo.cpx_timer   = NULL;
	cpxinfo.cpx_key     = NULL;
	cpxinfo.cpx_button  = NULL;
	cpxinfo.cpx_m1      = NULL;
	cpxinfo.cpx_m2      = NULL;
	cpxinfo.cpx_hook    = NULL;
	cpxinfo.cpx_close   = NULL;

	return( &cpxinfo );
}

/*
 **************************************************************************
**/

int cdecl cpx_call( GRECT *rect )
{
	int msg[8], button, ende;
	long oldset = get_config( );	/*Die alten Werte sichern*/
	
	w_rect = rect;

	maindial[ ROOT ].ob_x = w_rect->g_x;
	maindial[ ROOT ].ob_y = w_rect->g_y;

#ifdef _DEBUG_
	debug( "cpx_call", &savedata );
#endif

	load_buffer( );

	if( kaos_ok || magx_ok )
		setup_dial( );
	else
	{
		maindial[PFADPRUE].ob_state |= DISABLED;
		maindial[FASTLOAD].ob_state |= DISABLED;
		maindial[KOMPATIB].ob_state |= DISABLED;
		maindial[SMARTRED].ob_state |= DISABLED;
		maindial[GROWSHRI].ob_state |= DISABLED;
		maindial[HALTNTOS].ob_state |= DISABLED;
		maindial[PULLMENU].ob_state |= DISABLED;
	}

	set_language( savedata.language, FALSE );
	init_dialog( );
	object_draw( ROOT, MAX_DEPTH, w_rect );
	set_config( get_header( ));

	do
	{ 
   		button = ( *xcpb->Xform_do )( maindial, ROOT, msg );
   		ende = handle_dialog( button, msg );
	} while( !ende );

	if( button == MAINABBR )
	{
		upd_header( oldset );		/*...alten Werte nehmen*/
		set_config( oldset );
	}
	
	return( FALSE );
}

/*
 **************************************************************************
**/

int handle_dialog( int button, int *msg )
{
	/*Zuerst Nachrichten (negative Zahl) auswerten*/
	if( button == -1 && ( msg[0] == WM_CLOSED || msg[0] == AC_CLOSE ))
		return( TRUE );

	button &= 0x7fff;		/*Doppelklick-Bit erst jetzt lschen*/
							/*ab hier keine messages mehr mglich*/
	switch( button )
	{
		case MAINSAVE:
			if(( *xcpb->XGen_Alert )( SAVE_DEFAULTS ) != 0 )
			{
				upd_header( get_config( ));
				savedata.saved = TRUE;
				if(( *xcpb->CPX_Save )( &savedata, sizeof( SAVEDATA )) == 0 )
				{
					( *xcpb->XGen_Alert )( FILE_ERR );
					savedata.saved = FALSE;
				}
			}
			object_normal( button );
			object_draw  ( button, 1, w_rect );
			break;

		case MAININFO:
			handle_info( button, w_rect );
			break;

		case MAINBUOK:
			save_buffer( );
			object_normal( button );
			return( TRUE );
		case MAINABBR:
			object_normal( button );
			return( TRUE );
		default:			/*ALLE anderen Objekte!*/
			handle_bitset( button, w_rect );
			break;

	}

	return( FALSE );	/*FALSE: kein Abbruch der Schleife*/
}

/*
 **************************************************************************
**/

void save_buffer( void )
{
/*
	Speichert die Einstellungen in einem 64 Byte Puffer im RAM des CPX.
	Der Puffer ist nach Neuladen des CPX wieder gelscht.
*/
	memcpy(( *xcpb->Get_Buffer )( ), &savedata, sizeof( savedata ));
}

/*
 **************************************************************************
**/

void load_buffer( void )
{
	memcpy( &savedata, ( *xcpb->Get_Buffer )( ), sizeof( SAVEDATA ));
	upd_header( get_config( ));
}

/*
 **************************************************************************
**/

void save_header( void )
{
/*
	Speichert die Einstellungen im Header Puffer des CPX
	Der Header Puffer wird beim Speichern der Einstellungen in die
	CPX-Datei geschrieben.
*/

	upd_header( get_config( ));
	savedata.saved = TRUE;
}

/*
 **************************************************************************
**/

/*
	Zeigt die ersten 8 Bytes eines Speicherbereichs an
	- z.B. debug( "cpx_init", &savedata );
*/

#ifdef _DEBUG_
void debug( const char *str, void *buffer )
{
	unsigned char *ptr;

	ptr = (unsigned char *) buffer;
	printf( "[%-20.20s]" \
			"$%08lX %02X %02X %02X %02X %02X %02X %02X %02X\r\n",
			str,
			ptr, *( ptr + 0 ), *( ptr + 1 ), *( ptr + 2 ), *( ptr + 3 ),
			*( ptr + 4 ), *( ptr + 5 ), *( ptr + 6 ), *( ptr + 7 ));
}
#endif

/*
 **************************************************************************
**/

void init_dialog( void )
{
	long bitset;

	if(!( kaos_ok || magx_ok ))	return;

	bitset = get_config( );

	if( magx300 )
		set_te_ptext( PFADPRUE, (( bitset & SCB_FLPAR ) ^ SCB_FLPAR ));
	else
		set_te_ptext( PFADPRUE, (( bitset & SCB_PTHCK ) ^ SCB_PTHCK ));

	set_te_ptext( FASTLOAD, (  bitset & SCB_NFAST ));
	set_te_ptext( KOMPATIB, (( bitset & SCB_CMPTB ) ^ SCB_CMPTB ));
	set_te_ptext( SMARTRED, (  bitset & SCB_NSMRT ));
	set_te_ptext( GROWSHRI, (  bitset & SCB_NGRSH ));
	set_te_ptext( HALTNTOS, (  bitset & SCB_NHALT ));
	set_te_ptext( PULLMENU, (( bitset & SCB_PULLM ) ^ SCB_PULLM ));
}

/*
 **************************************************************************
**/

void set_te_ptext( int object, long bitval )
{
	TEDINFO *tedinfo = maindial[ object ].ob_spec.tedinfo;
	char *_einaus;
	int color;

	if( bitval )
	{
		_einaus = t_aus;
		color = RED;
	}
	else
	{
		_einaus = t_ein;
		color = BLUE;
	}

	strcpy( tedinfo->te_ptext, _einaus );
	tedinfo->te_color &= ~0xf00;
	tedinfo->te_color |= ( color << 8 );
}

/*
 **************************************************************************
**/

void setup_dial( void )
{
	char *kaosmagx, *mon;
	long p_value = kaosvers;
	unsigned char tag, monat;
	unsigned int  jahr;
	unsigned char  version1, version2;
	unsigned char  release;
	AESVARS *av;

	if(!( kaos_ok || magx_ok ))
		return;

	av = ((MAGX_COOKIE *) magxvers) -> aesvars;

	if( kaos_ok )
	{
		kaosmagx	= "KAOS-TOS";
		tag			= (unsigned char) (( p_value >> 24 ) & 0xff );
		monat		= (unsigned char) (( p_value >> 16 ) & 0xff );
		jahr		= (unsigned int)  ( p_value & 0xffff );
		version1	= (unsigned char) (( tosvers >>  8 ) & 0xff );
		version2	= (unsigned char) ( tosvers & 0xff );
	}
	else if( magx_ok && av )
	{
		kaosmagx = "MagiC";
		tag			= (unsigned char) (( av->date >> 24 ) & 0xff );
		monat		= (unsigned char) (( av->date >> 16 ) & 0xff );
		jahr		= (unsigned int)  ( av->date & 0xffff );
		version1	= (unsigned char) (( av->version >> 8 ) & 0xff );
		version2	= (unsigned char) ( av->version & 0xff );
		release		= (unsigned char) ( av->release & 0xff ) + 0xE0;
	}

	/* der ASCII-Monat mu noch in einen Wert umgerechnet werden*/
	monat = ( monat & 0xf ) + (( monat >> 4 ) & 0xf ) * 10;

	if ( monat >= 1 && monat <= 12 )
		mon = month[ savedata.language ][ monat - 1 ];

	if( kaos_ok )
	{
		if( savedata.language == lang_GER )
		{
			sprintf( kaosstrn, " %s %x.%02x %s %x. %s %x ", kaosmagx,
				version1, version2, "vom", tag, mon, jahr );
		}
		if( savedata.language == lang_ENG )
		{
			sprintf( kaosstrn, " %s %x.%02x %s %s %x, %x ", kaosmagx,
				version1, version2, "from", mon, tag, jahr );
		}
	}
	else if( magx_ok && av )
	{
		if( savedata.language == lang_GER )
		{
			sprintf( kaosstrn, " %s %x.%02x%c %s %x. %s %x ", kaosmagx,
				version1, version2, release, "vom", tag, mon, jahr );
		}
		if( savedata.language == lang_ENG )
		{
			sprintf( kaosstrn, " %s %x.%02x%c %s %s %x, %x ", kaosmagx,
				version1, version2, release, "from", mon, tag, jahr );
		}
	}
}

/*
 **************************************************************************
**/

#pragma warn -rvl
long tosversion( void )
{
	tosvers = ((SYSHDR *) (long) *((void **) _sysbase )) -> os_version;
}
#pragma warn +rvl

/*
 **************************************************************************
**/

void upd_header( long bitset )
{
	savedata.kaosconf = bitset;
}

/*
 **************************************************************************
**/

long get_header( void )
{
	long bitset = get_config( );

	if( savedata.kaosconf )
	{
		/*Alle relevanten Bits lschen*/
		bitset &= ~(
			SCB_PTHCK |		/*Bit  0: 0x0001 Pfadberprfung ein*/
			SCB_NFAST |		/*Bit  4: 0x0010 Fastload fr Diskette aus*/
			SCB_CMPTB |		/*Bit  5: 0x0020 TOS- Kompatibilitt ein*/
			SCB_NSMRT |		/*Bit  6: 0x0040 "smart redraw" aus*/
			SCB_NGRSH |		/*Bit  7: 0x0080 Grow- und Shrinkboxen aus*/
			SCB_NHALT |		/*Bit  8: 0x0100 kein Halt nach TOS- Programmen*/
			SCB_PULLM |		/*Bit 10: 0x0400 Pulldown- Mens*/
			SCB_FLPAR );	/*Bit 11: 0x0800 DMA-Parallelbetrieb Floppy aus*/
		bitset |= savedata.kaosconf;
	}

	return( bitset );
}

/*
 **************************************************************************
**/

void object_xywh( GRECT *therect, int object )
{
	OBJECT *tree = maindial;

	objc_offset( tree, object, &therect->g_x, &therect->g_y );
	therect->g_w = tree[ object ].ob_width;
	therect->g_h = tree[ object ].ob_height;
}

/*
 **************************************************************************
**/

void handle_bitset( int object, GRECT *rect )
{
	GRECT r1;
	long bitset;
	int popup, p, bitclr, bitnum;
	char *items[ 2 ];

	if(!( kaos_ok || magx_ok ))	return;

	items[ 0 ] = p_aus;
	items[ 1 ] = p_ein;
	
	switch( object )
	{
		case PFADPRUE:	bitnum = ( magx300 ) ? SCB_FLPAR : SCB_PTHCK;
						break;
		case FASTLOAD:	bitnum = SCB_NFAST;	break;
		case KOMPATIB:	bitnum = SCB_CMPTB;	break;
		case SMARTRED:	bitnum = SCB_NSMRT;	break;
		case GROWSHRI:	bitnum = SCB_NGRSH;	break;
		case HALTNTOS:	bitnum = SCB_NHALT;	break;
		case PULLMENU:	bitnum = SCB_PULLM;	break;
		default:	return;
	}

/*
	Ausnahme-Bits schalten Funktion ein, wenn das Bit gesetzt - die
	anderen Bits schalten die Funktion aus, wenn das Bit gesetzt wird.
	Durch die Behandlung dieser Bits als Ausnahme-Bits wird der Code krzer
*/

	bitclr = (( bitnum == SCB_PTHCK ||
				bitnum == SCB_FLPAR ||
				bitnum == SCB_CMPTB ||
				bitnum == SCB_PULLM ) ? 1 : 0 );

	object_xywh( &r1, object );		/*Objekt-Koordinaten holen*/

	bitset = get_config( );
	popup  = ( bitset & bitnum ) ? 0 : 1;	/*Voreinstellung aus/ein*/

	if( bitclr )		/*wenn ausschalten*/
		popup ^= 1;		/* -> umgekehrt*/

	p  = ( *xcpb->Popup )( items, 2, popup, 3, &r1, rect );

	if( p != -1 && p != popup )
	{
		if( bitclr )
			p ^= 1;		/*Wenn Ausnahme-Bits -> umgekehrt*/

/*
	Wenn 'Aus' -> Bitnummer setzen - wenn 'Ein' -> Bitnummer lschen
*/
		if( p == 0 )
			bitset |= bitnum;
		else
			bitset &= ~bitnum;

		upd_header ( bitset );
		set_config ( bitset );
		init_dialog( );
		object_draw( object, 1, rect );
	}

}

/*
 **************************************************************************
**/

void handle_info( int object, GRECT *rect )
{
/*
	- Hier soll man Optionen einstellen knnen, z.B. Sprache,
	  dann man nur noch eine Version der RSC-Datei
	- evtl. mehrere Seiten der Konfig-Variablen whlen
*/
	GRECT r1;
	int popup, p, anz_popup;
	char *items[ 4 ];

	if( savedata.language == lang_GER )
	{
		items[ 0 ] = "  Deutsch  ";
		items[ 1 ] = "  Englisch ";
		items[ 2 ] = "  Info     ";
		popup = 0;
	}
	else
	{
		items[ 0 ] = "  German  ";
		items[ 1 ] = "  English ";
		items[ 2 ] = "  Info    ";
		popup = 1;
	}

	if( kaos_ok || magx_ok )
		anz_popup = 3;
	else
		anz_popup = 2;

	object_xywh( &r1, object );

	p  = ( *xcpb->Popup )( items, anz_popup, popup, 3, &r1, rect );

	if( p != -1 && p != popup )
	{
		switch( p )
		{
			case 0:
			case 1:	set_language( p, TRUE );	break;
			case 2:	object_xywh( &r1, MAININFO );
					( *xcpb->Popup )( &kaosstrn, 1, -1, 3, &r1, rect );
		}

		object_draw( object, 1, rect );
	}
}

/*
 **************************************************************************
**/

void set_language( int p, int redraw )
{
	int iPTHCK, iNFAST, iCMPTB, iNSMRT, iNGRSH, iNHALT, iPULLM;
	int it_ein, it_aus, ip_ein, ip_aus;
	int it_Save, it_Ok, it_Abbr;

	if( p == 0 )
	{
		iPTHCK	= ( magx300 ) ? FLPARGER : PTHCKGER;
		iNFAST	= NFASTGER;
		iCMPTB	= CMPTBGER;
		iNSMRT	= NSMRTGER;
		iNGRSH	= NGRSHGER;
		iNHALT	= NHALTGER;
		iPULLM	= PULLMGER;
		it_ein	= T_EINGER;
		it_aus	= T_AUSGER;
		ip_ein	= P_EINGER;
		ip_aus	= P_AUSGER;
		it_Save	= T_SICGER;
		it_Ok	= T_OKGER;
		it_Abbr	= T_ABBGER;
		savedata.language = lang_GER;
	}
	if( p == 1 )
	{
		iPTHCK	= ( magx300 ) ? FLPARENG : PTHCKENG;
		iNFAST	= NFASTENG;
		iCMPTB	= CMPTBENG;
		iNSMRT	= NSMRTENG;
		iNGRSH	= NGRSHENG;
		iNHALT	= NHALTENG;
		iPULLM	= PULLMENG;
		it_ein	= T_EINENG;
		it_aus	= T_AUSENG;
		ip_ein	= P_EINENG;
		ip_aus	= P_AUSENG;
		it_Save	= T_SICENG;
		it_Ok	= T_OKENG;
		it_Abbr	= T_ABBENG;
		savedata.language = lang_ENG;
	}

	maindial[T_PFADPR].ob_spec.free_string =
		strgdial[iPTHCK].ob_spec.free_string;
	maindial[T_FASTLO].ob_spec.free_string =
		strgdial[iNFAST].ob_spec.free_string;
	maindial[T_KOMPAT].ob_spec.free_string =
		strgdial[iCMPTB].ob_spec.free_string;
	maindial[T_SMARTR].ob_spec.free_string =
		strgdial[iNSMRT].ob_spec.free_string;
	maindial[T_GROWSH].ob_spec.free_string =
		strgdial[iNGRSH].ob_spec.free_string;
	maindial[T_HALTNA].ob_spec.free_string =
		strgdial[iNHALT].ob_spec.free_string;
	maindial[T_PULLME].ob_spec.free_string =
		strgdial[iPULLM].ob_spec.free_string;
	maindial[MAINSAVE].ob_spec.free_string =
		strgdial[it_Save].ob_spec.free_string;
	maindial[MAINBUOK].ob_spec.free_string =
		strgdial[it_Ok].ob_spec.free_string;
	maindial[MAINABBR].ob_spec.free_string =
		strgdial[it_Abbr].ob_spec.free_string;

	setup_dial( );

	t_ein = strgdial[it_ein].ob_spec.free_string;
	t_aus = strgdial[it_aus].ob_spec.free_string;
	p_ein = strgdial[ip_ein].ob_spec.free_string;
	p_aus = strgdial[ip_aus].ob_spec.free_string;

	init_dialog( );

	if( redraw )
	{
		redraw_object( T_PFADPR );
		redraw_object( T_FASTLO );
		redraw_object( T_KOMPAT );
		redraw_object( T_SMARTR );
		redraw_object( T_GROWSH );
		redraw_object( T_HALTNA );
		redraw_object( T_PULLME );
		redraw_object( PFADPRUE );
		redraw_object( FASTLOAD );
		redraw_object( KOMPATIB );
		redraw_object( SMARTRED );
		redraw_object( GROWSHRI );
		redraw_object( HALTNTOS );
		redraw_object( PULLMENU );
		redraw_object( MAINSAVE );
		redraw_object( MAINBUOK );
		redraw_object( MAINABBR );
	}
}

/*
 **************************************************************************
**/

void redraw_object( int object )
{
	GRECT r1;

	object_xywh( &r1, object );
	object_draw( object, 1, &r1 );
}

/*
 **************************************************************************
**/

void object_draw( int object, int depth, GRECT *clip )
{
	objc_draw( maindial, object, depth,
		clip->g_x, clip->g_y, clip->g_w, clip->g_h );
}

/*
 **************************************************************************
**/

void object_normal( int object )
{
	maindial[ object ].ob_state &= ~SELECTED;
}

/*
 **************************************************************************
**/

void set_config( long val )
{
	if( kaos_ok || magx_ok )
		Sconfig( SC_SET, val );
}

/*
 **************************************************************************
**/

long get_config( void )
{
	return(( kaos_ok || magx_ok ) ? Sconfig( SC_GET, 0L ) : 0L );
}

/* eof - End of File*/